//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
//
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//------------------------------------------------------------------------------
//RC10

unit Dictionary;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,  Dialogs,
  StdCtrls, ComCtrls, Grids, ExtCtrls, Masks, jpeg, CheckLst, Config;

const
 DictionaryDir : string = '\Dictionary\';


type
  DIndexAtom = record
     _From, _To: integer;
  end;

  DictionBaseRecord = record
   Name,
   FileName,
   Enabled  : TStringList;
  end;

//RC11
  TDiction = record //  
    Text, //     
    Rules : TStringList;  //     ,    
   end;

//        
  TDictionaryForm = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormActivate(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
  public
  end;

//   
  function LoadDiction: boolean;//  
  function CompareMask( Text: string; RulesCount: dword; var ResultText: string ):boolean;//        
  function FiltrText( Text : string ): string;//     Text   ,      

var
  DictionaryForm: TDictionaryForm;//  
  Diction : TDiction;//  
  WordPosition : integer;
  DictionBase : DictionBaseRecord;

  DIndex: array [0..255] of DIndexAtom;
  SelCount: integer;

implementation
{$R *.dfm}
//     DictionaryFileName    Diction
function LoadDiction: boolean;
var
 FileName : string;
 DText: TStringList; //           ()
 RulesCount, j: integer; //     
 CutText, CutRules: string;
 Flag: boolean;
begin
//---


 if Diction.Text = nil then Diction.Text := TStringList.Create; //   Text   Diction    
 if Diction.Rules = nil then Diction.Rules := TStringList.Create; //     Rules
 Diction.Text.Clear; //   
 Diction.Rules.Clear;//   
 Diction.Text.Add( '' );
 Diction.Rules.Add( '' );


 DText := TStringList.Create;//     

 FileName := '1.dic';

 DText.Clear;
 DText.LoadFromFile( StartDir + '\Dictionary\1.dic' ); //  ,               
 DText.Sort;


//   DText   ,   ,  
//             Diction

 for RulesCount := 0 to DText.Count-1 do //         
                                         //         ,       
  begin
   if DText[RulesCount] <> '' then //    
    begin
     flag := true; //     "="       

     if ( DText[RulesCount][1] <> '\' ) //          (    )
        and
        ( DText[RulesCount][1] <> '/' )
        and
        ( DText[RulesCount][1] <> ';' ) then
       begin
        for j:=1 to length( DText[RulesCount] ) do //      "="
         if DText[RulesCount][j]= '=' then flag := false; //   "="    

         if not(flag) then //   ,       "="
          begin
           flag := true; //  
           CutText := ''; //         "=",     
           CutRules := ''; //      ,    ,  

           for j:=1 to length(DText[RulesCount]) do //    ,     
            begin
             if ( DText[RulesCount][j]<>'=' ) //       
                and//   
                ( flag ) then CutText := CutText + DText[RulesCount][j] //       ,       
                  else// 
                    begin
                     flag := false;//  ,  
                     if ( DText[RulesCount][j]<>'=' )//        (     )        
                        and //   
                        ( not(flag) ) then CutRules := CutRules + DText[RulesCount][j];//     ,      
            end;
          end;

          if DIndex[Ord(CutText[1])]._From = 0 then DIndex[Ord(CutText[1])]._From := Diction.Text.Count-1;
          if DIndex[Ord(CutText[1])]._To < Diction.Text.Count then DIndex[Ord(CutText[1])]._To := Diction.Text.Count-1;

          Diction.Text.Add( CutText ); //     (     ) 
          Diction.Rules.Add( CutRules ); //          
       end;
    end; //      
  end;
  end;

   DText.Destroy;
   LoadDiction := True; //    ,   
end;

//     Text   RulesCount,      
//    ResultText.      "*", "?"
function CompareMask( Text: string; RulesCount: dword; var ResultText: string ):boolean;
var
 NWCount : integer; //      
begin
 result := false; //   - ,   
//RC12

 if MatchesMask( AnsiUpperCase( Text ),AnsiUpperCase(Diction.Text[RulesCount])) then //       
   begin //    
    result := true; //   

//     ,       "*",      
//        ""  Text,        ("*")
   if Diction.Text[RulesCount][length(Diction.Text[RulesCount])]='*' then //  "*"    
     begin //         "*"    ,      
      ResultText := Diction.Rules[RulesCount]; //       
      for NWCount := length(Diction.Text[RulesCount])-1 to length(Text) do
       ResultText := ResultText + Text[NWCount]; //     
     end
    else
     begin
      if Diction.Text[RulesCount][1]='*' then //      
       begin
        ResultText := ''; //  
        for NWCount := 1 to length(Text)-length(Diction.Text[RulesCount])+1 do //           
         ResultText := ResultText + Text[NWCount];
        ResultText := ResultText + Diction.Rules[RulesCount]; //    
       end
      else
        ResultText := Diction.Rules[RulesCount]; //                
    end;
   end;
end;

function IsNotTerminalChar( c: char ):boolean;
begin
 case c of
  ' ', '.', ',', '!', '?', #$0D, #$0A: Result := false;
 else
  Result := true;
 end;
end;
//   Text,   (   ) 
function FiltrText( Text : string ): string;
var
 TextCount, DWordCount, RulesCount : integer;
 MirrorText, NextWord, NextDoubleWord, s4, s5 : string;
 L: integer;
 TerminalChar2, TerminalChar: Char;
begin
 WordPosition := 0;
 if Text = '' then Exit; //   ,  , ,  

 MirrorText := Text; //     
 TextCount  := 0; //      
 s5  := '';  //    ,  

 l := length(MirrorText);
 repeat //  ,     ,  
  Application.ProcessMessages;
  NextWord := ''; //       


  repeat //   

   inc( TextCount ); //    
   if TextCount <= l then //      
    begin
     if IsNotTerminalChar(MirrorText[TextCount])  then NextWord := NextWord + MirrorText[TextCount] //            
    end
   else TextCount := length(MirrorText); //  ? :)    ""   ,
                                            //                          ,     
                                            //                     MirrorText[TextCount]    ()    
  until (not(IsNotTerminalChar(MirrorText[TextCount])))  //    
       or
        ( TextCount = length(MirrorText)); //    

  TerminalChar := MirrorText[TextCount];

  NextDoubleWord := NextWord + ' '; //               ,               ,   
  DWordCount := TextCount;  //    () ,            () 

  repeat //   ,    ,      
   Application.ProcessMessages;
   inc( DWordCount );
   if DWordCount <= length(MirrorText) then
    begin
     if IsNotTerminalChar(MirrorText[DWordCount]) then NextDoubleWord := NextDoubleWord + MirrorText[DWordCount]
    end
   else DWordCount := length(MirrorText);
  until (not(IsNotTerminalChar(MirrorText[DWordCount])))
       or
        ( DWordCount = length(MirrorText));

  TerminalChar2 := MirrorText[DWordCount];

 if NextWord <> '' then
 begin
 s4 := ''; //                
 WordPosition := WordPosition + length(NextWord);
 for RulesCount := DIndex[Ord(NextWord[1])]._From to DIndex[Ord(NextWord[1])]._To do //     
  begin
   if length(Diction.Text[RulesCount]) > 1 then        //        
     if length( NextWord ) > 1 then                    //         
      begin
       if ( Diction.Text[RulesCount][2] = NextWord[1]) //  ,             
         or
          ( Diction.Text[RulesCount][2] = NextWord[2]) then  //    ,                 
         begin
          if not( CompareMask( NextWord, RulesCount, s4 )) then //       
           begin
            if CompareMask( NextDoubleWord, RulesCount, s4 ) then  //    ,   
             begin
              TextCount := DWordCount;                           //    ,         
              TerminalChar :=  TerminalChar2;
              break;                                             //           s4
             end;
            end
           else break;
         end;
       end;
   end;


 if s4 = '' then // if not find then masks search
 begin
 for RulesCount := DIndex[Ord('*')]._From to DIndex[Ord('*')]._To do //     
  begin
   if length(Diction.Text[RulesCount]) > 1 then        //        
     if length( NextWord ) > 1 then                    //         
      begin
       if ( Diction.Text[RulesCount][2] = NextWord[1]) //  ,             
         or
          ( Diction.Text[RulesCount][2] = NextWord[2]) then  //    ,                 
         begin
          if not( CompareMask( NextWord, RulesCount, s4 )) then //       
           begin
            if CompareMask( NextDoubleWord, RulesCount, s4 ) then  //    ,   
             begin
              TextCount := DWordCount;                           //    ,         
              TerminalChar :=  TerminalChar2;
              break;                                             //           s4
             end;
            end
           else break;
         end;
       end;
   end;
 end;
 //  e              

  if s4 = '' then s5 := s5 + NextWord + TerminalChar
             else s5 := s5  + s4 + TerminalChar; //       
 
 end;


 until TextCount >= length(MirrorText); //       

 FiltrText := s5; //  ,  s5

end;

procedure TDictionaryForm.FormActivate(Sender: TObject);
var
 i : integer;
begin
 LoadDiction;

 Label1.Caption := 'Diction size:' + inttostr( Diction.Text.Count-1 );

 Edit1.Width := StringGrid1.ColWidths[0];
 Edit2.Width := StringGrid1.ColWidths[1];

 StringGrid1.RowCount := Diction.Text.Count-1;
 StringGrid1.Cols[0].Clear;
 StringGrid1.Cols[1].Clear; 

 StringGrid1.Cells[0,0] := 'Text';
 StringGrid1.Cells[1,0] := 'Rules';

 for i:=1 to Diction.Text.Count-1 do
  begin
   StringGrid1.Cells[0,i] := Diction.text[i];
   StringGrid1.Cells[1,i] := Diction.Rules[i];
  end;



end;

procedure TDictionaryForm.StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
 Edit1.Text := StringGrid1.Cells[0,ARow];
 Edit2.Text := StringGrid1.Cells[1,ARow];
 SelCount   := ARow;
end;

procedure TDictionaryForm.CheckListBox1ClickCheck(Sender: TObject);
begin


end;

//   ,    .     
//          StringGrid
procedure TDictionaryForm.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 s : string;
 i : integer;
begin
  StringGrid1.Canvas.Font.Color := clBlack; //   
  StringGrid1.Canvas.Font.Style := [fsUnderline,fsBold]; //  -  
  StringGrid1.Canvas.Brush.Color := $00EEEbE2; //  ...
  StringGrid1.Canvas.FillRect(Rect); //    
  StringGrid1.Canvas.TextOut(Rect.Left+10, Rect.Top+1, StringGrid1.Cells[ACol,Arow] ); //    
  StringGrid1.Canvas.FillRect(Rect); //  
  s := ''; //       ,                      "..."
   if StringGrid1.Cells[ACol,Arow] <> '' then //     (     )
    begin
     for i:=1 to length(StringGrid1.Cells[ACol,Arow]) do //               
      if StringGrid1.Canvas.TextWidth( s + '...    ' ) < StringGrid1.ColWidths[ACol] then
       s := s + StringGrid1.Cells[ACol,Arow][i]; //  
      s := s + '...'; //   
    end;
end;


procedure TDictionaryForm.Button1Click(Sender: TObject);
begin
 if StringGrid1.Cols[0].IndexOf( Edit1.Text ) > -1 then
  ShowMessage('Exist')
 else
  begin
   StringGrid1.RowCount := StringGrid1.RowCount + 1;
   StringGrid1.Cols[0].Add( Edit1.Text );
   StringGrid1.Cols[1].Add( Edit2.Text );
  end;
end;

procedure TDictionaryForm.Button4Click(Sender: TObject);
begin
 if StringGrid1.Cols[0].IndexOf( Edit1.Text ) > -1 then
  ShowMessage('Exist')
 else
  begin
   StringGrid1.Cells[0,SelCount] := Edit1.Text;
   StringGrid1.Cells[1,SelCount] := Edit2.Text;
   StringGrid1.Refresh;
  end;
end;

procedure TDictionaryForm.Button2Click(Sender: TObject);
begin
 FormActivate( Sender );
end;

procedure TDictionaryForm.Button3Click(Sender: TObject);
var
 i: integer;
 S:TstringList;
begin
 s := TStringList.Create;
 for i:= 1 to Diction.Text.Count-1 do
  begin
   s.Add( Diction.Text[i] + '=' + Diction.Rules[i]  )
  end;
 s.SaveToFile('1.dic');
 s.Destroy;
end;

end.
