//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
//
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//------------------------------------------------------------------------------
unit View;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus,Config, jpeg, Buttons,ScrollInd,Service;
const
  CPWin1251 = 0;
  CPKOI8    = 1;
type
//   (MIDI) 
  TViewForm = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure LocalCreate;
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WindowMenuClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure ScrollBar1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBar1Exit(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ConvertFromKOI8toWin;
    procedure ConvertFromWintoKoi8;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  public
    RichEdit1: TRichEdit;
    WindowMenuItem: TMenuItem;
    WindowToolButton: TToolButton;
    IndexFileName : integer;

    BookMarkImages : array [1..10] of TImage;
    BookMarkLabels : array [1..10] of TLabel;
    BookMarkOffset : array [1..10] of Dword;

    f : boolean;
    CodePage : byte;
  end;
var
  ViewForm: TViewForm; //   ,    MainForm
  a : array [0..65535] of byte;
  b : array [1..10] of longint;

implementation

uses Main;
{$R *.dfm}
//     FormActivate     
//        
procedure TViewForm.FormActivate(Sender: TObject);
begin
 with MainForm do //     (MainForm),        
  begin
   CloseFileItem.Enabled      := true; //      
   BoldFontItem.Enabled       := true;
   NormalFontItem.Enabled     := true;
   ItalicFontItem.Enabled     := true;
   ViewItem.Enabled       := true;
   WindowsItem.Enabled    := true;
   ReadText.Enabled       := true;
   ToolButton2.Enabled := true;
   ReadButton.Enabled  := true;
   PauseButton.Enabled := true;
  end;
 if WindowToolButton <> nil then WindowToolButton.Down := true;
end;
procedure TViewForm.LocalCreate;
var
  t : trect;
begin
 RichEdit1 := TRichEdit.Create(Self);
 RichEdit1.Parent := ViewForm;

 RichEdit1.Align := alClient;  //    
 RichEdit1.Lines.Clear;        //  
 RichEdit1.Color := StringToColor(GetMConf('rViewBgColor'));
 RichEdit1.WordWrap := StrToBool(GetMConf('rViewWordWrap'));
 RichEdit1.Font.Name := GetMConf('rViewFont');
 RichEdit1.Font.Size := StrToInt(GetMConf('rViewfontsize'));
 RichEdit1.Font.Color := StringToColor(GetMConf('rViewFontColor'));
 RichEdit1.HideSelection := false;
 RichEdit1.HideScrollBars := false;
 RichEdit1.ScrollBars := ssBoth;

 RichEdit1.Paragraph.FirstIndent := 10;


//    RichEdit1
 RichEdit1.OnKeyPress         := RichEdit1KeyPress;  //   
 RichEdit1.OnSelectionChange  := RichEdit1SelectionChange; //   
 RichEdit1.OnKeyDown :=  RichEdit1KeyDown;
 RichEdit1.SetFocus;
 f := true;
end;

//    RichEdit KeyPress,       
//    ,       
//   \,      RichEdit.ReadOnly 
//         ,     
//     
procedure TViewForm.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 Key := chr(0); //    
 inherited; //  RichEdit   ,     
//       Key  var,      
//    ,           
//   
end;
//           RichEdit
//      
procedure TViewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 with MainForm do //     ,      
  begin           //      ,     ,  
                  //    FormActivate    
   CloseFileItem.Enabled      := false;
   BoldFontItem.Enabled       := false;
   NormalFontItem.Enabled     := false;
   ItalicFontItem.Enabled     := false;
   ViewItem.Enabled       := false;
   WindowsItem.Enabled    := false;
   ReadText.Enabled       := false;

   ToolButton2.Enabled := false;

   OpenFiles.Delete( IndexFileName );

   WindowsItem.Delete(MainForm.WindowsItem.IndexOf( WindowMenuItem )); //     WindowMenuItem   Windows1
   WindowToolButton.Destroy;
   Speech1.Stop; //     
  end;

  Action := caFree; //     
end;
//     OnClick     Windows1
//            
procedure TViewForm.WindowMenuClick(Sender: TObject);
begin
 Show;  //    ,      
 WindowToolButton.Down := true;
end;

procedure TViewForm.FormDeactivate(Sender: TObject);
begin
 if WindowToolButton <> nil then WindowToolButton.Down := false;
end;

procedure TViewForm.RichEdit1SelectionChange(Sender: TObject);
var
 RealCaretPosition : TPoint;
begin
//        StatusBar  
 MainForm.StatusBar1.Panels[1].Text := GetLConf('sbpage')+' '+inttostr((RichEdit1.CaretPos.Y + 1) div 40 + 1);
 MainForm.StatusBar1.Panels[2].Text := GetLConf('sbline')+' '+inttostr( RichEdit1.CaretPos.Y + 1);
 MainForm.StatusBar1.Panels[3].Text := GetLConf('sbchar')+' '+ inttostr( RichEdit1.CaretPos.X + 1);
//        StatusBar  
 MainForm.StatusBar1.Panels[4].Text := 'size: '+ inttostr( length(RichEdit1.Text))+' byte';
 f := false;

 f := true;
 GetCaretPos( RealCaretPosition );
end;

procedure TViewForm.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if ssCtrl in Shift then
  begin
   Case Key of
    ord('1') : if b[1] <> -1 then RichEdit1.SelStart := BookMarkOffset[1];
    ord('2') : if b[2] <> -1 then RichEdit1.SelStart := BookMarkOffset[2];
    ord('3') : if b[3] <> -1 then RichEdit1.SelStart := BookMarkOffset[3];
    ord('4') : if b[4] <> -1 then RichEdit1.SelStart := BookMarkOffset[4];
    ord('5') : if b[5] <> -1 then RichEdit1.SelStart := BookMarkOffset[5];
    ord('6') : if b[6] <> -1 then RichEdit1.SelStart := BookMarkOffset[6];
    ord('7') : if b[7] <> -1 then RichEdit1.SelStart := BookMarkOffset[7];
    ord('8') : if b[8] <> -1 then RichEdit1.SelStart := BookMarkOffset[8];
    ord('9') : if b[9] <> -1 then RichEdit1.SelStart := BookMarkOffset[9];
    ord('0') : if b[10]<> -1 then RichEdit1.SelStart := BookMarkOffset[10];
   end;
   key := 0;
  end;
  inherited;
end;

procedure TViewForm.ScrollBar1Change(Sender: TObject);
var
 b : integer;
begin
 if not(f) then exit;
 b := 0;
 RichEdit1.SelStart := b;
end;

procedure TViewForm.BitBtn1Click(Sender: TObject);
begin
 RichEdit1.SelStart := 0;
end;

procedure TViewForm.BitBtn2Click(Sender: TObject);
begin
 RichEdit1.SelStart := length(RichEdit1.Text );
end;

procedure TViewForm.ScrollBar1Scroll(Sender: TObject;  ScrollCode: TScrollCode; var ScrollPos: Integer);
var
 p : TPoint;
begin
   GetCursorPos(p);
   MainForm.SetFocus;
end;

procedure TViewForm.ScrollBar1Exit(Sender: TObject);
begin
ScrollIndForm.Hide;
end;

procedure TViewForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ScrollIndForm.Hide;
end;

procedure TViewForm.ConvertFromKOI8toWin;
var
 s : string;
begin
 s := RichEdit1.Text;
 s := Koi8ToWin(s);
 RichEdit1.Text := s;
end;

procedure TViewForm.ConvertFromWintoKoi8;
begin
 RichEdit1.Text := WinToKOI8( RichEdit1.Text );
end;


procedure TViewForm.Button1Click(Sender: TObject);
begin
 ConvertFromKOI8toWin;
end;

procedure TViewForm.Button2Click(Sender: TObject);
begin
 ConvertFromWintoKoi8;
end;

end.
